/**
 * 转换菜单
 * 如果服务端接口返回json数据和左边菜单json数据，
 * 结构对象都不一样时就自定义一个方法来处理
 * 处理完成后返回 Array
 * meunData 服务端请求回来的菜单
 * 输出菜单结构必须如下
 * L_router左边路由
 * T_router顶级路由，不嵌套在任何路由下
 {
  {
  "L_router":[
    {
      "id": "3",
      "name": "test3",
      "isopen":false,
      "Iconname": "ios-navigate",
      "title": "管理1003",
      "componepath": "/test003",
      "children": [
        {
          "id": "3-1",
          "name": "asyn_test",
          "Iconname": "ios-navigate",
          "title": "asyn_test",
          "active":false,
          "componepath": "/asyn_test"
        },
        {
          "id": "3-2",
          "name": "test3-2",
          "Iconname": "ios-keypad",
          "title": "test0032",
          "active":false,
          "componepath": "/test0032"
        },
        {
          "id": "3-3",
          "name": "test3-3",
          "Iconname": "ios-keypad",
          "title": "三级测试",
          "active":false,
          "componepath": "/asyn_test",
          "children": [
            {
              "id": "3-3-1",
              "name": "test3-3-1",
              "Iconname": "ios-keypad",
              "title": "test3-3-1",
              "active":false,
              "nomeunli": true,
              "componepath": "/test3-3-1/:id"
            },
            {
              "id": "3-3-2",
              "name": "test3-3-2",
              "Iconname": "ios-keypad",
              "title": "test3-3-2",
              "active":false,
              "componepath": "/test3-3-2"
            }
          ]
        }
      ]
    }
  ],
  "T_router":[]
  }
 */
export const meObjCovion = (meunData) => {
  // 服务端数据多了.result对象
  let result = meunData.result
  // 如果没有result对象时也能用
  let meunliobj = meunData
  // 处理result内的数据
  if (result && typeof result !== 'undefined') {
    meunliobj = {
      L_router: [],
      T_router: []
    }
    // 递归服务端的数据，添加用到的字段名，和删除没用到的对象名
    // 服务原始数据（meunData没改动过的）还会保留在store内可以，
    // 全局的控件内用this.$store.state.saverTree取出
    if (meunData.success || (result && result.length > 0)) {
      const toMeunPopFor = (children) => {
        for (let r = 0; r < children.length; r++) {
          let subitem = children[r]
          let compathrs = subitem.frontUrl
          if (compathrs && typeof compathrs !== 'undefined') {
            let rename = 'go_' + subitem.id
            let title = subitem.name
            let reicon = subitem.icon
            let recompath = subitem.frontUrl
            if (recompath.indexOf('/') < 0) {
              recompath = '/' + recompath
            }
            let nomeunli = true
            if (subitem.type === 0 || subitem.type === 1) {
              nomeunli = null
            }
            subitem['Iconname'] = subitem.icon ? reicon : 'ios-navigate'
            subitem['title'] = title
            subitem['name'] = rename
            subitem['nomeunli'] = nomeunli
            subitem['isopen'] = true
            subitem['componepath'] = recompath
            delete subitem.frontUrl
            delete subitem.icon
            if (!subitem.children || subitem.children.length < 1) {
              delete subitem.children
            }
          }
          if (subitem.children && subitem.children.length > 0) {
            toMeunPopFor(subitem.children)
          }
        }
      }
      toMeunPopFor(result)
    }
    meunliobj['L_router'] = result
  }
  return meunliobj
}

// ajax全局配置
/**
 * errorAfter 请求失败后的处理
 * responseAfter 请求成功后处理res是成功返回的所有，如：（res）=>{  return res}
 * headers配置参数和axios原生一样，具体看官方配置
 */
export const axiosConfig = {
  errorAfter: (error) => {
    if (/401/g.test(error)) {
      history.pushState({}, 'ISP', '/login')
      location.reload()
    }
    if (/403/g.test(error)) {
      history.pushState({}, 'ISP', '/')
      location.reload()
    }
  },
  responseAfter: null,
  headers: null
}
