import config from "_s/config.json"
import axios from "axios"
export default {
    data () {
      return {
        currentNo: 1,
        pageTotalSize: 1,
        tbodyheight: 350,
        sysTemModal:false,
        tableRos: [],
        total: 0,
        orderBy:true,
        pageSize: config.limit,
        editPasswordModal:false
      }
    },
    computed: {
       getTree () {
         let menuList = this.$store.getters.getRoletree
         return menuList
       },
      reColumnsAction () {
         this.columns.map(item=>{
           if(item.render){
             item.render = this[item.key]
           }
         })
        return this.columns
      }
    },
    methods: {
      Inquire() {
        let rolepage = this.$refs.rolepage
        if (rolepage && typeof rolepage !== 'undefined') {
          rolepage.currentPage = 1
        }
        this.resettbody(1)
      },
      resettbody(pageNo) {
        pageNo = pageNo?pageNo:1
        let rolepage = this.$refs.rolepage
        if (rolepage && typeof rolepage !== 'undefined') {
          pageNo = pageNo?pageNo:rolepage.currentPage
        }
        this.getTableSaver(pageNo)
      },
      tbodyPost (url, params) {
        let method = 'post'
        axios[method](url, params).then((res) => {
            let result = res.data.result
            if(result.data.length == 0 && params.name && params.pageNo !=1){
              params.pageNo = 1
              this.tbodyPost(url,params)
              return;
            }
            if (result && typeof result !== 'undefined') {
              let rowlist = result.data
              this.total = result.total
              this.pageTotalSize = Math.ceil(this.total / this.pageSize)
              this.tableRos = rowlist
            } else {
              if (!res.data.success) {
                this.$Message.destroy()
                this.$Message.error(res.data.error)
              }
            }
            this.$Loading.finish()
        }).catch((res) => {
          this.$Message.destroy()
          this.$Message.error(res.response.data.error)
        })
      },
      sortChange (trfind) {
        let asc = (trfind.order == 'asc') ? true : false
        this.orderBy = asc
        let rolepage = this.$refs.rolepage
        let pageNo = rolepage.current
        this.getTableSaver(pageNo)
      },
      pageChange(pageNo) {
        this.getTableSaver(pageNo)
      },
      closemodal () {
        this.cleardom(0)
        this.sysTemModal = false
        if (this.clearform && typeof this.clearform === 'function') {
          this.clearform()
        }
      },
      cleardom (time) {
        let rtime = time || 340
        if (this.$refs.modelform) {
          setTimeout(()=>{
            this.$refs.modelform.resetFields()
          }, rtime)
        }
      },
      authrOperaTing (h, params) {

        return h('span','test')
      },
      claertbodykey (keyname,id) {
        let tbodydata = this.getselCheckeddata()
        for (let r = 0; r < tbodydata.length;r++) {
          let item = tbodydata[r]
          item[keyname] = false
          if (item.id === id) {
            item[keyname] = true
          }
        }
        return tbodydata
      },
      statusfnbtn(h,row) {
        let statusrs = row.status
        let txt = "启用"
        if (statusrs === 1) {
          txt = "冻结"
        }
        let statusbtn =  h('span', {
          on: {
           click: () => {
            let tbodydata = this.claertbodykey('isloading',row.id)
            this.tableRos = tbodydata
            this.freeze(row)
           }
          }
        },txt)
        if (row['isloading'] === true) {
          statusbtn =  h('Button',{props:{type:'text',loading:true}},txt)
        }
        if (row['name'] === 'admin' && row['id'] === 1) {
          statusbtn =  h('Button',{props:{type:'text',disabled:true}},txt)
        }
        return statusbtn
      },
      entchmtype (h, params) {
        let type = params.row.type
        let userType = ''
        if (type === 3) {
           userType = '电商'
        }
        if (type === 4) {
           userType = '出版社'
        }
        if (type === 5) {
           userType = '印厂'
        }
        return h('span', {},userType)
      },
      dataSourtype (h, params) {
        let statusrs = params.row.type
        // 1-电商、2-出版社、3-ERP、4-MES，5-APS
        let txt = ""
        if (statusrs === 1) {
          txt = "电商"
        }
        if (statusrs === 2) {
          txt = "出版社"
        }
        if (statusrs === 3) {
          txt = "ERP"
        }
        if (statusrs === 4) {
          txt = "MES"
        }
        if (statusrs === 5) {
          txt = "APS"
        }
        return h('span', {
          props: {
            type: 'text'
          },
          class:['statusbtn'],
          on: {
           click: () => {
             this.freeze(params.row)
           }
          }
        },txt)
      },
      datastatus (h, params) {
        let statusrs = params.row.status
        let txt = "启用"
        if (statusrs === 1) {
          txt = "冻结"
        }
        return h('Button', {
          props: {
            type: 'text',
            size: 'small'
          },
          class:['statusbtn'],
          on: {
           click: () => {
             this.freeze(params.row)
           }
          }
        },txt)
      },
      status (h, params) {
        let statusrs = params.row.status
        let txt = "冻结"
        if (statusrs === 1) {
          txt = "启用"
        }
        return h('span', {
          props: {
            type: 'text'
          }
        },txt)
      },
      tbodywinresize () {
        let tbodyh = document.body.clientHeight
        this.tbodyheight = tbodyh - 290
     },
     onPageSizeChange(pagesize) {
       this.pageSize = pagesize
       this.resettbody()
     },
     getselCheckeddata() {
      let tabledata = this.$refs.roletable.objData
      let selelist = []
      for (let r in tabledata) {
          let item = tabledata[r]
          selelist.push(item)
      }
      return selelist
     },
      geturl (utype) {
        let getApiUrlList = this.$store.getters.getApiUrlList
        let path = this.$route.path.replace('/main','')
        path = path.replace(/\/[0-9]?$/,'')
        let urlall = getApiUrlList.find(uitem => {
          return uitem.path === path && uitem.urltype === utype
        })
        return urlall
      },
      valemail (rule, value, callback) {
        if (value && typeof value !== 'undefined') {
          if (!(/^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/.test(value))) {
            callback(new Error('邮箱格式不正确'))
          } else {
             callback()
          }
       } else {
          callback()
       }
      },
      valmobile (rule, value, callback) {
       if (value && typeof value !== 'undefined') {
          if (!(/^1[34578]\d{9}$/.test(value))) {
            callback(new Error('手机号格式不正确'))
          } else {
             callback()
          }
       } else {
          callback()
       }
     }
    },
    mounted () {
      if (this.$refs.roletable) {
         this.$store.commit('setWinSize', this.tbodywinresize)
         this.tbodywinresize()
      }
    }
}
